/* KinokoControlPanel.cc */
/* Created by Enomoto Sanshiro on 27 September 2001. */
/* Last updated by Enomoto Sanshiro on 27 September 2001. */


#include <string>
#include "KinokoControl.hh"
#include "KinokoControlWidget.hh"
#include "KinokoControlPanel.hh"

using namespace std;



TKinokoControlPanel::TKinokoControlPanel(TKinokoControl* Control, const string& RootPath)
{
    _Control = Control;
    _RootPath = RootPath;
}

TKinokoControlPanel::~TKinokoControlPanel()
{
}

void TKinokoControlPanel::AddConstant(map<string, string>& OptionTable)
{
    string Name = OptionTable["name"];
    string Value = OptionTable["value"];
    
    TKinokoControlWidget* ControlWidget;
    ControlWidget = new TKinokoConstantWidget(Name, Value);

    _Control->AddWidget(ControlWidget);
    _Control->AddInputWidget(ControlWidget);
}

void TKinokoControlPanel::ReadScript(const std::string& Script)
{
    _Control->ReadScript(Script);
}

#if 1
//... for backward compatibility ...//
void TKinokoControlPanel::BeginAction(std::map<std::string, std::string>& OptionTable)
{
    _CurrentActionName = OptionTable["name"];
}

void TKinokoControlPanel::EndAction(const std::string& ActionScript)
{
    _Control->AddActionScript(_CurrentActionName, ActionScript);
}
#endif
