/* KinokoMonitor.hh */
/* Created by Enomoto Sanshiro on 16 May 2004. */
/* Last updated by Enomoto Sanshiro on 16 May 2003. */


#ifndef __KinokoMonitor_hh
#define __KinokoMonitor_hh


#include <string>
#include <vector>
#include <map>
#include "MushXml.hh"


class TKinokoMonitorComponentCondition {
  public:
    TKinokoMonitorComponentCondition(const std::string& Name);
    virtual ~TKinokoMonitorComponentCondition();
    virtual void Update(const std::string& CheckTime, const std::string& State, const std::string& HeartBeatCount);
    const std::string& Name(void) const { return _Name; }
    long CheckTime(void) const { return _CheckTime; }
    const std::string& State(void) const { return _State; }
    double HeartBeatCount(void) const { return _HeartBeatCount; }
  protected:
    std::string _Name;
    long _CheckTime;
    std::string _State;
    long _HeartBeatCount;
};


class TKinokoMonitor: public TMushSaxDocumentHandler {
  public:
    TKinokoMonitor(void);
    virtual ~TKinokoMonitor();
  protected:
    virtual void Update(const std::string& RegistryFileName);
  public:
    virtual void startElement(const std::string& name, const TMushSaxAttributeList& attribute_list);
    virtual void endElement(const std::string& name);
  protected:
    TMushSaxParser* _Parser;
    std::vector<std::string> _ComponentNameList;
    std::map<std::string, TKinokoMonitorComponentCondition*> _ComponentList;
    long _UpdateTime;
  private:
    bool _IsIteratingPropertyList;
    std::string _CurrentComponentName;
    std::string _CheckTime, _State, _HeartBeatCount;
};


#endif
